/* Sistemas Integrados TEKNISA

Nome: 520D_DFSSTPS_GERA_NOTAFISCAL_FECHAMENTO.SQL

Descrio:
PROCEDIMENTOS PARA GERAO DE FECHAMENTO DE NOTAS FISCAIS

Criao:
05/10/2005 - Fabrcio Marcelo da Silva
*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'GERA_NOTAFISCAL_FECHAMENTO' AND
	           TYPE = 'P' 			  AND
              U.UID = O.UID        AND
              U.NAME = USER)

DROP PROCEDURE GERA_NOTAFISCAL_FECHAMENTO
GO

CREATE PROCEDURE GERA_NOTAFISCAL_FECHAMENTO
   @P_CDFILIAL       VARCHAR(04),
   @P_NRLANCTONF     VARCHAR(10),
   @P_DATAPROC       DATETIME     = NULL,
   @P_NRLANCESTQ     VARCHAR(10)  = NULL,
   @P_EVOLESTOQ      VARCHAR(01)  = 'S',
   @P_CDOPERADOR     VARCHAR(12)  = NULL,
   @P_IDATUESTOQ     VARCHAR(01)  = 'S'
AS
   DECLARE @V_CDEMPRESA      VARCHAR(02);
   DECLARE @V_CDINSCESTA     VARCHAR(16);
   DECLARE @V_CDTIPOOPER     VARCHAR(02);
   DECLARE @V_CDCLIENTE      VARCHAR(21);
   DECLARE @V_CDFORNECED     VARCHAR(21);
   DECLARE @V_CDFILIRECE     VARCHAR(04);
   DECLARE @V_CLIENTENF      VARCHAR(21);
   DECLARE @V_ORIGDESTNF     VARCHAR(01);
   DECLARE @V_CDFILIEMIT     VARCHAR(04);
   DECLARE @V_IDGERAVENC     VARCHAR(01);
   DECLARE @V_IDSISTEMA      VARCHAR(03);
   DECLARE @V_NRLANCTO       VARCHAR(10);
   DECLARE @V_NRLANCESTQ     VARCHAR(10);
   DECLARE @V_IDATUESTTPOP   VARCHAR(01);
   DECLARE @V_IDUTCTRLSNCM   VARCHAR(03);
	DECLARE @V_DTINICIAL      DATETIME;
   DECLARE @V_DTFINAL        DATETIME;
   DECLARE @V_DTENTRSAID     DATETIME;
   DECLARE @V_VRNOTAFISC     NUMERIC;
   DECLARE @V_VRLIQUIDO      NUMERIC;
   DECLARE @V_DIFERENCA      NUMERIC;
	DECLARE @V_COUNTPRODRSNCM NUMERIC;	
   
   DECLARE @V_RESULT_DADOS_FIN VARCHAR(50);
BEGIN
   SET @V_CDEMPRESA       = NULL;
   SET @V_CDINSCESTA      = NULL;
   SET @V_CDTIPOOPER      = NULL;
   SET @V_CDCLIENTE       = NULL;
   SET @V_CDFORNECED      = NULL;
   SET @V_CDFILIRECE      = NULL;
   SET @V_DTENTRSAID      = NULL;
   SET @V_ORIGDESTNF      = NULL;
   SET @V_CDFILIEMIT      = NULL;
   SET @V_IDSISTEMA       = NULL;
   SET @V_NRLANCTO        = NULL;
   SET @V_IDGERAVENC      = NULL;
	SET @V_IDUTCTRLSNCM    = 'NAO';
   SET @V_VRLIQUIDO       = 0;
	SET @V_COUNTPRODRSNCM  = 0;

   SET @V_NRLANCESTQ      = @P_NRLANCESTQ;


   SELECT @V_CDEMPRESA = MAX(N.CDEMPRESA), @V_CDINSCESTA = MAX(N.CDINSCESTA), @V_CDTIPOOPER = MAX(N.CDTIPOOPER),
          @V_CDCLIENTE = MAX(N.CDCLIENTE), @V_CDFORNECED = MAX(N.CDFORNECED), @V_CDFILIRECE = MAX(N.CDFILIRECE),
          @V_DTENTRSAID = MAX(N.DTENTRSAID), @V_ORIGDESTNF = MAX(N.IDORIGDESTNF), @V_CDFILIEMIT = MAX(N.CDFILIEMIT),
          @V_IDSISTEMA = MAX(N.IDSISTEMA)
   FROM NOTAFISCAL N
   WHERE N.CDFILIAL   = @P_CDFILIAL   AND
         N.NRLANCTONF = @P_NRLANCTONF;			
			
/*
	--------------------------- Rotina: Rastreabilidade de medicamentos --------------------------- 
*/
	IF @V_IDSISTEMA = 'EXP' BEGIN
		SELECT @V_IDUTCTRLSNCM = ISNULL(IDUTCTRLSNCM, 'NAO')
		  FROM FILIAL
		 WHERE CDFILIAL = @V_CDFILIEMIT;
		
		IF @V_IDUTCTRLSNCM = 'SIM' BEGIN
		
			SELECT @V_COUNTPRODRSNCM = COUNT(1)
			  FROM ITEMPRODUTO IP
			 WHERE IP.CDFILIAL   = @P_CDFILIAL
				AND IP.NRLANCTONF = @P_NRLANCTONF
				AND EXISTS (SELECT 1
								  FROM INFADICPROD I
								 WHERE I.IDPRODRASTRSNCM = 'SIM'
									AND IP.CDPRODUTO      = I.CDPRODUTO);
									
			IF @V_COUNTPRODRSNCM > 0 BEGIN
				UPDATE NOTAFISCAL
					SET IDNFDRASTRSNCM = 'SIM'
				 WHERE CDFILIAL   = @P_CDFILIAL
					AND NRLANCTONF = @P_NRLANCTONF;
			END;		
		END;
	END;
	
/*
	---------------------------------------------------------------------------------------
*/				

   SELECT @V_NRLANCTO = MAX(NRLANCTONF)
   FROM CONTARECEBER
   WHERE CDFILIAL   = @P_CDFILIAL   AND
         NRLANCTONF = @P_NRLANCTONF;

   IF @V_ORIGDESTNF = 'F' BEGIN
      SET @V_CLIENTENF = @V_CDFORNECED;
   END
   ELSE IF @V_ORIGDESTNF = 'L' BEGIN
      SET @V_CLIENTENF = @V_CDFILIRECE;
   END
   ELSE BEGIN
      SET @V_CLIENTENF = @V_CDCLIENTE;
   END;

   SELECT @V_IDATUESTTPOP = MAX(IDATUESTTPOP)
   FROM TIPOOPERAC
   WHERE IDENTRSAIDOP = 'S'  AND
         CDTIPOOPER = @V_CDTIPOOPER ;

   IF @V_IDATUESTTPOP = 'N' BEGIN
      SET @V_NRLANCESTQ = '';
   END;

   INSERT INTO ITEMENCARGO
      (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
      (SELECT @P_CDFILIAL, @P_NRLANCTONF, CDENCARGO, 0
       FROM ENCARGO
       WHERE CDENCARGO NOT IN (SELECT CDENCARGO
                               FROM ITEMENCARGO
                               WHERE CDFILIAL   = @P_CDFILIAL AND
                                     NRLANCTONF = @P_NRLANCTONF));

   EXEC IMPOSTO_SAIDA @V_CDEMPRESA, @V_CDINSCESTA, @V_CDTIPOOPER, @V_CLIENTENF,
                      @P_CDFILIAL,  @P_NRLANCTONF, @V_DTENTRSAID, @V_NRLANCESTQ,
                      @V_VRNOTAFISC, @P_CDOPERADOR;

   IF NOT @V_CDTIPOOPER IN ('02','04','06','07','09') BEGIN

      SELECT @V_IDGERAVENC = MAX(IDGERAVENC)
      FROM TIPOOPERAC
      WHERE CDTIPOOPER   = @V_CDTIPOOPER AND
            IDENTRSAIDOP = 'S';

      IF (@V_IDGERAVENC = 'S') AND ((@V_IDSISTEMA <> 'PDV') AND (@V_NRLANCTO IS NULL)) BEGIN
         IF (@V_IDSISTEMA = 'FAI') OR (@V_IDSISTEMA = 'DFS') OR (@V_IDSISTEMA = 'EXP') BEGIN
            EXEC GERA_DADOS_FINANCEIRO P_CDFILIAL,           /*   IN FILIAL.CDFILIAL%TYPE0, */ 
                                       P_NRLANCTONF,         /*   IN NOTAFISCAL.NRLANCTONF%TYPE,  */
                                       @V_CDFILIEMIT,        /*   P_CDFILIPROC IN FILIAL.CDFILIAL%TYPE, */
                                       'L',                  /*   P_IDOPERACAO IN VARCHAR2,*/
                                       @V_RESULT_DADOS_FIN;  /*   P_RESULTADO OUT VARCHAR2)*/
         END
         ELSE BEGIN
            EXEC APURAC_VENC @P_CDFILIAL, @V_CLIENTENF, @P_NRLANCTONF;
         END;
         
      END;
      
   END;

   IF NOT @V_NRLANCESTQ IS NULL BEGIN
      IF ISNULL(@P_EVOLESTOQ, 'S') <> 'N' BEGIN
         SELECT @V_VRLIQUIDO = SUM(VRTOTAITEM - VRDESCITEM)
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = @P_CDFILIAL AND
               NRLANCTONF = @P_NRLANCTONF;

         SET @V_DIFERENCA = @V_VRNOTAFISC - @V_VRLIQUIDO;

         EXEC CUSTO_LIQUIDO @P_CDFILIAL, @V_NRLANCESTQ, @V_VRLIQUIDO, @V_DIFERENCA, 'N';

         IF @V_DTENTRSAID < @P_DATAPROC BEGIN
            SET @V_DTINICIAL = @V_DTENTRSAID;
         END
         ELSE BEGIN
            SET @V_DTINICIAL = @P_DATAPROC;
         END;

         IF @V_DTENTRSAID > @P_DATAPROC BEGIN
            SET @V_DTFINAL = @V_DTENTRSAID;
         END
         ELSE BEGIN
            SET @V_DTFINAL = @P_DATAPROC;
         END;

         UPDATE ITLANCTOEST
         SET  IDEVOLESTOQ = 'S'
         WHERE CDFILIAL    = @P_CDFILIAL AND
               NRLANCESTQ  = @V_NRLANCESTQ;

         IF ISNULL(@P_IDATUESTOQ,'S') <> 'N' BEGIN
            EXEC ATUALIZA_ESTOQUE @V_CDFILIEMIT, @V_DTINICIAL, @V_DTFINAL, @P_CDFILIAL, @V_NRLANCESTQ;
         END;
      END   
      ELSE BEGIN

         UPDATE ITLANCTOEST
         SET  IDEVOLESTOQ = 'N'
         WHERE CDFILIAL    = @P_CDFILIAL AND
               NRLANCESTQ  = @V_NRLANCESTQ;

      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_NOTAFISCAL_FECHAMENTO','6.35.036';
GO
